# Generated by go2rpm 1
%bcond_without check
%global debug_package %{nil}

# https://qpid.apache.org
%global goipath         qpid.apache.org
%global goipathgh       github.com/apache/qpid-proton/go/pkg
%global tag             0.32.0-rc1

%ifarch x86_64 amd64
%global archdir         linux_amd64
%endif
%ifarch ppc64le
%global archdir         linux_ppc64le
%endif
%ifarch aarch64
%global archdir         linux_arm64
%endif

%global godocs          readme-go-get.md README.md

Name:           golang-qpid-apache
Version:        0.32.0
Release:        rc1.6%{?dist}
Summary:        Golang binding library for qpid-proton
License:        BSD and ASL 2.0
URL:            https://gitbox.apache.org/repos/asf/qpid-proton.git/

# Thanks to non-traditional repo the source had to be creted manually.
# Use following tool to get the source: "get_source.sh <version>"
Source0:        golang-qpid-apache-0.32.0-rc1.tar.gz

BuildRequires:  %{?go_compiler:compiler(go-compiler)}%{!?go_compiler:golang}
BuildRequires:  qpid-proton-c-devel

Requires:       qpid-proton-c-devel
Provides:       golang(%{goipath}) = %{version}-%{release}
Provides:       golang(%{goipath}/electron) = %{version}-%{release}
Provides:       golang(%{goipath}/proton) = %{version}-%{release}
Provides:       golang(%{goipath}/amqp) = %{version}-%{release}
Provides:       golang(%{goipathgh}) = %{version}-%{release}
Provides:       golang(%{goipathgh}/electron) = %{version}-%{release}
Provides:       golang(%{goipathgh}/proton) = %{version}-%{release}
Provides:       golang(%{goipathgh}/amqp) = %{version}-%{release}


%description
Apache Qpid™ makes messaging tools that speak AMQP and support many languages and platforms.


%prep
%autosetup -n %{goipath}


%build
pushd ./go/pkg
for ali in %{goipath} %{goipathgh}; do
  mkdir -p $(dirname ./build/src/$ali)
  ln -s $PWD ./build/src/$ali
done

# create binary packages
export GOPATH=$PWD/build
for pkg in amqp electron proton; do
  pushd ./build/src/%{goipath}/$pkg
  go install .
  popd
done

pushd ./build/src/%{goipath}
go mod init %{goipath}
cat go.mod
popd
popd


%install
pushd ./go/pkg
# copy binary packages
install -d -p %{buildroot}/%{gopath}/pkg/%{archdir}/%{goipath}/
pushd ./build/pkg/%{archdir}/%{goipath}/
for file in $(find . -iname "*.a") ; do
    cp -pav $file %{buildroot}/%{gopath}/pkg/%{archdir}/%{goipath}/$file
done
popd
rm -fr ./build ./internal
# copy packages source
install -d -p %{buildroot}/%{gopath}/src/%{goipath}/
install -d -p %{buildroot}/%{gopath}/src/%{goipathgh}
install -d -p %{buildroot}/%{gopath}/pkg/mod/%{goipath}@%{tag}/
for file in ./* ; do
    if [ -d $file ]; then
        cp -rpav $file %{buildroot}%{gopath}/src/%{goipath}/
        cp -rpav $file %{buildroot}%{gopath}/src/%{goipathgh}/
        cp -rpav $file %{buildroot}/%{gopath}/pkg/mod/%{goipath}@%{tag}/
    fi
done
popd


%files
%{gopath}/src/%{goipath}
%{gopath}/src/%{goipathgh}
%{gopath}/pkg/%{archdir}/%{goipath}
%{gopath}/pkg/mod/%{goipath}@%{tag}/


%changelog
* Tue Sep 01 23:00:30 CEST 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.6
- Provide also go module

* Tue Sep 01 15:00:30 CEST 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.5
- Provide source files also on github path
- Fix require for qpid-proton-c

* Tue Sep 01 14:26:30 CEST 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.3
- Provide also binary packages

* Mon Aug 24 10:59:02 CEST 2020 Martin Magr <mmagr@redhat.com> - 0.32.0-rc1.1
- Initial package
